--
-- The following VHDL code was generated by
-- BRUSEY20 - PIC to VHDL Parser - v2.1
-- Copyright (C) 1995 by Tom Mayo
--
-- To contact the author:  tcmayo@mntr02.psf.ge.com
--
--                         Tom Mayo
--                         67 Wilson St.
--                         Pittsfield, MA  01201
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of version 2 of the GNU General Public License as
-- published by the Free Software Foundation.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY your_entity IS
  PORT (
    clk : IN std_logic;
    I : IN std_logic;
    rst_n : IN std_logic;
    O : OUT std_logic
  );
END your_entity;

ARCHITECTURE exemplar OF your_entity IS

  TYPE state_type IS ( s0a, s0b, s0c, s0d, s0e, s1a, s1b, s1c, s1f, s1g, s1d, s1e );
  SIGNAL current_state, next_state : state_type;
  SIGNAL next_O : std_logic;

BEGIN

  registers : PROCESS ( clk, rst_n )
  BEGIN
    IF ( rst_n='0') THEN
      O<='0';
      current_state <= s0a;
    ELSIF ( clk'EVENT AND clk = '1' ) THEN
      O <= next_O;
      current_state <= next_state;
    END IF;
  END PROCESS;

  transitions : PROCESS ( current_state, I )
  BEGIN
    CASE current_state IS
      WHEN s0a =>
        IF ( I='1' ) THEN
          next_O<='0';
          next_state <= s0b;
        ELSE
          next_O<='0';
          next_state <= s0a;
        END IF;
      WHEN s0b =>
        IF ( I='1' ) THEN
          next_O<='0';
          next_state <= s0c;
        ELSE
          next_O<='0';
          next_state <= s0a;
        END IF;
      WHEN s0c =>
        IF ( I='1' ) THEN
          next_O<='0';
          next_state <= s0d;
        ELSE
          next_O<='0';
          next_state <= s0a;
        END IF;
      WHEN s0d =>
        IF ( I='1' ) THEN
          next_O<='0';
          next_state <= s0e;
        ELSE
          next_O<='0';
          next_state <= s0a;
        END IF;
      WHEN s0e =>
        IF ( I='1' ) THEN
          next_O<='1';
          next_state <= s1a;
        ELSE
          next_O<='0';
          next_state <= s0a;
        END IF;
      WHEN s1a =>
        IF ( I='0' ) THEN
          next_O<='1';
          next_state <= s1b;
        ELSE
          next_O<='1';
          next_state <= s1a;
        END IF;
      WHEN s1b =>
        IF ( I='0' ) THEN
          next_O<='1';
          next_state <= s1c;
        ELSE
          next_O<='1';
          next_state <= s1a;
        END IF;
      WHEN s1c =>
        IF ( I='0' ) THEN
          next_O<='1';
          next_state <= s1d;
        ELSE
          next_O<='1';
          next_state <= s1a;
        END IF;
      WHEN s1f =>
        IF ( I='0' ) THEN
          next_O<='1';
          next_state <= s1g;
        ELSE
          next_O<='1';
          next_state <= s1a;
        END IF;
      WHEN s1g =>
        IF ( I='0' ) THEN
          next_O<='0';
          next_state <= s0a;
        ELSE
          next_O<='1';
          next_state <= s1a;
        END IF;
      WHEN s1d =>
        IF ( I='0' ) THEN
          next_O<='1';
          next_state <= s1e;
        ELSE
          next_O<='1';
          next_state <= s1a;
        END IF;
      WHEN s1e =>
        IF ( I='0' ) THEN
          next_O<='1';
          next_state <= s1f;
        ELSE
          next_O<='1';
          next_state <= s1a;
        END IF;
    END CASE;
  END PROCESS;
END exemplar;
